class Ribbon extends Boid{

  ArrayList points;
  int ribbonLength;
  color currentColor;
  color endColor;
  
  Ribbon(Vector3D l, float ms, float mf ){
    //points = new ArrayList();
    super(l, ms,  mf);
    points = new ArrayList();
    this.ribbonLength = 10;
  }

  void run (ArrayList boids) {
    flock(boids);
    update();
    borders();
    render();
  }

  void update() {
    points.add(new Vector3D(pos.x, pos.y, pos.z));
    if(points.size() > ribbonLength){
      points.remove(0);
    }
    vel.add(acc);
    vel.limit(maxspeed);
    pos.add(vel);
    acc.setXYZ(0,0,0);
  }

  void borders() {
    //this is more complicated since we are dealing with many points going off screen
    if(pos.x > width){
      if(points.size() > 0){
        Vector3D v = (Vector3D)points.get(0);
        if(v.x > width){
          pos.x = 0;
          while(points.size() > 0){
            points.remove(0);
          }
        }
      } 
      else {
        pos.x = 0; 
      }
    }
    if(pos.y > height){
      if(points.size() > 0){
        Vector3D v = (Vector3D)points.get(0);
        if(v.y > height){
          pos.y = 0;
          while(points.size() > 0){
            points.remove(0);
          }
        }
      } 
      else {
        pos.y = 0;
      }
    }
    if(pos.x < 0){
      if(points.size() > 0){
        Vector3D v = (Vector3D)points.get(0);
        if(v.x < 0){
          pos.x = width;
          while(points.size() > 0){
            points.remove(0);
          }
        }
      } 
      else {
        pos.x = width;
      }
    }
    if(pos.y < 0){
      if(points.size() > 0){
        Vector3D v = (Vector3D)points.get(0);
        if(v.y < 0){
          pos.y = height;
          while(points.size() > 0){
            points.remove(0);
          }
        }
      }
      else {
        pos.y = height;
      }
    }
  }

  void render() {
    strokeWeight(1.2);
    noFill();
    //map the ribbon position to a pixel in the video (640x480 down to 320x240)
    int cx = (pos.x < width && pos.x >= 0)? floor(pos.x/2) : 319;
    int cy = (pos.y < height && pos.y >= 0)? floor(pos.y/2) : 239;
    
    //set the color based on glove size and ribbon position
    currentColor = myMovie.pixels[ cy*320 + cx ];
    endColor = currentColor - color(0,0,0,255);
    float scaleVal = 1 - FMS[fnum].h/255.0f;
    currentColor = lerpColor(currentColor, endColor, scaleVal);
    stroke( currentColor );
    
    //draw the ribbon
    beginShape();
    if(points.size() > 0){
      for(int i = points.size() - 1; i >= 0; i--){
        Vector3D p = (Vector3D)points.get(i);
        curveVertex(p.x, p.y);
        curveVertex(p.x, p.y);
      }
    }
    endShape();
  }
}
