/****************************************/
/*    White Glove Tracking              */
/*    Video w/ Data Example             */
/*    whiteglovetracking.com            */
/*    Started 05.21.2007                */
/*    Evan Roth evan@ni9e.com           */
/****************************************/

/**
White Glove Flocking
David Wicks david@thingsiam.com
*/

//import libs
import processing.video.*;
//import processing.opengl.*;

//make vars
frame FM;
frame FMS[];
int comma;
String temp_f, temp_x, temp_y, temp_w, temp_h;
int f, x, y, w, h;
int fnum;
float t, inc;
Movie myMovie;
PFont courier;
PImage prevFrame;

//David's stuff for flocking
Flock flock;
int numRibbons = 12;


void setup(){
    size(640, 480);
    background(0);
    smooth();
    //load movie
    myMovie = new Movie(this, "whiteglove.mov");
    
    myMovie.loop();
    
    //load font
    courier = loadFont("CourierNewPSMT-14.vlw");
    textFont(courier, 16);
    
    //init time vars
    t = 0.0f;
    inc = 1.0f / 30.0f;
    
    //load in data from text file
    //String lines[] = loadStrings("median_degap_smooth.txt");
    String lines[] = loadStrings("wgt_data_v1.txt");
    
    println("there are " + lines.length + " lines");
    
    //make room for all objs
    FMS = new frame[lines.length];
    
    //loop through text file, save data into frame objects
    for (int i=0; i < lines.length; i++) {

        //intit vars
        comma = 0;
        temp_f = "";
        temp_x = "";
        temp_y = "";
        temp_w = "";
        temp_h = "";
     
        //loop through all chars on the line
        for (int j=0; j < lines[i].length(); j++) {
            char c = lines[i].charAt(j);    //this is the char we are looking at
            if(c == ','){                   //which comma are we on
                 comma++;
            }
            if(comma == 0){                //break into multiple strings
               temp_f += c;
            }
            else if(comma == 1){
               if(c != ','){
                 temp_x += c;
               }
            }else if(comma == 2){
               if(c != ','){
                 temp_y += c;
               }
            }else if(comma == 3){
               if(c != ','){
                 temp_w += c;
               }
            }else if(comma == 4){
               if(c != ','){
                 temp_h += c;
               }
            }
        }
    
        //convert strings to ints
        f = int(temp_f);
        x = int(temp_x);
        y = int(temp_y);
        w = int(temp_w);
        h = int(temp_h);
        t += inc;
    
        //load data into object
        FM = new frame(f, x, y, w, h, t);
        FMS[i] = FM;
        //FMS[i].print();
    }
    
    //create the flock
    flock = new Flock();
    while(flock.getSize() < numRibbons){
      Ribbon r = new Ribbon(new Vector3D(random(width), random(height)), 5, 1 );
      flock.addBoid( r );
    }
    //set up prevFrame
    prevFrame = createImage(width, height, ARGB);
}
//load movie data 
void movieEvent(Movie myMovie) {
  myMovie.read();
}

void draw(){
   //draw movie frame
   //image(myMovie, 0, 0, 640, 480);
   
   //figure out frame # based on time from .mov
   fnum = int(myMovie.time()*29.96);
   
   /*
   //animate by cpu clock
   if(fnum < FMS.length){
     float tt = millis()/1000.0f;
     fnum = int(tt*29.96);
   }
   */
   //blur the last frame
   
   //draw the flock
   flock.run();
}
